<?php declare(strict_types=1);

namespace Test\Unit\Query;

use BitBadger\PDODocument\Field;
use BitBadger\PDODocument\Query\Delete;
use PHPUnit\Framework\Attributes\TestDox;
use PHPUnit\Framework\TestCase;

/**
 * Unit tests for the Delete class
 */
class DeleteTest extends TestCase
{
    #[TestDox('By ID succeeds')]
    public function testByIdSucceeds(): void
    {
        $this->assertEquals("DELETE FROM over_there WHERE data->>'id' = @id", Delete::byId('over_there'),
            'DELETE statement not constructed correctly');
    }

    public function testByFieldsSucceeds(): void
    {
        $this->assertEquals("DELETE FROM my_table WHERE data->>'value' < @max AND data->>'value' >= @min",
            Delete::byFields('my_table', [Field::LT('value', 99, '@max'), Field::GE('value', 18, '@min')]),
            'DELETE statement not constructed correctly');
    }
}
